Get Schedule of Values (SOVs) For Base Commit Type BPs

POST /ws/rest/service/v2/projectsovsheet/sov

Available: Version 25.4 and later

Purpose

Get the schedule of values (SOV) for General Spends, Payment Application, and Summary Payment Application SOV types for Base Commit BP Type. This REST service is only available for projects whose Status is Active. If the Status of a project’s shell is set to Inactive, On-Hold, or View Only, an error message is returned.

Prerequisites

Ensure you have Full Access or Get permissions for CBS Services to retrieve SOVs.

Request Format

Send a request as a JSON map with the following structure:

{

"options":{

"project_number": "<value>",

"bpname" : "<value>",

"record_no" : "<value>"

}

}

Note:

Any other fields in the options map will be ignored.

Request Parameters

Specify the following parameters in the Options JSON map:

Request Parameter Required? Data Type Description
project_number Yes String A valid project/shell number.
bpname Yes String The business process name for which the SOVs are being retrieved. For example, Contracts.
record_no Yes String The BP record number. For example, CON-99993.

Response Format

A JSON object is returned in the following format:

{

"data": [],

"message": [<list of messages>],

"status": <REST status code value>,

"rest_audit_id": <id from the audit table>

}

A successful response displays a status code 200.

A failed response displays a message with a status code.

Sample Success Request

Send a request to retrieve SOVs in the following format:

{

"options": {

"project_number" : "P-0007",

"bpname": "Contracts",

"record_no": "CON-000055"

}

}

Sample Success Response

A successful response with status code 200 displays in the following format:

{

"data": [

{

"SOV": {

"SOV_header": {

"c1": "Ref.",

"c2": "Description",

"c3": "Cost Code",

"c4": "Breakdown"

},

"SOV_row": [{

"c1": 1,

"c2": "L1",

"c3": "01800",

"c4": ""

}

]

}

}

],

"message": ["success"],

"status": 200,

"rest_audit_id": 6320

}

Sample Failed Response

A failed response displays validation errors with the corresponding status code in the following format:

{

"data": [],

"message": [

"Create/Update/Delete cannot be peformed when project/shell status is Inactive or View-Only or On-Hold."

],

"status": 1245,

"rest_audit_id": 6321

}

Supported Validation Messages and Status Codes

The following validation messages and status codes display in the response when incorrect values are provided in the request:

Field Name Use-case Scenario Status Code Error Message
project_number project_number is not specified. 13001 Project/Shell number is mandatory and is missing in the input request
project_number project_number is inactive. 602 Project/Shell Number is not correct.
project_number Multiple project numbers are specified in the request. 1245 Create/Update/Delete cannot be performed when project/shell status is Inactive or View-Only or On-Hold.
project_number SOV does not exist. The record is not approved and the SOV has not yet been created. 853 SOV does not exist.
bpname BP name is invalid or not specified in the request. 603 Business Process Name is required.
bpname A different business process is used. 11010 SOV does not exist for this business process.
record_no Record number is invalid or not specified in the request. 657 Invalid record_no.
record_no Record has no rows. 200 Empty row data shown.
Not applicable Invalid JSON input 1059 Invalid JSON Input: Expected a '[' or '{' in parseObject at character 578.
Not applicable Either parameter is not string. 1707 Invalid input parameter.
Not applicable Exception 11011 Could not retrieve SOV Information.